'From Smalltalk-80 of February 20, 1985 on 25 February 1985 at 10:49:34 pm'!



!Form class methodsFor: 'instance creation'!
dotOfSize: diameter
	"Create a form which contains a round black dot."
	"Uses Mac calls in the upper left of the display."
	| frame displayBits dot |
	frame _ 0@0 corner: diameter@diameter.
	displayBits _ Form fromDisplay: frame.  "save old display bits"
	Mac eraseRect: frame; fillOval: frame pat: Mac black.
	dot _ Form fromDisplay: frame.
	dot offset: (diameter//-2) asPoint.
	displayBits display.  "restore old display bits"
	^ dot

	"(Form dotOfSize: 30) displayAt: Sensor cursorPoint"! !

!Form class methodsFor: 'examples'!
toothpaste: diam		"Form toothpaste: 30"
	"Draws wormlike lines by laying down images of spheres.
	See Ken Knowlton, Computer Graphics, vol. 15 no. 4 p352.
	Draw with mouse button down; terminate by option-click."
	| highlight ball filter point queue port |
	highlight _ Form extent: diam@diam fromArray: #() offset: (diam//-2) asPoint.
	#(1 2 3 5) do:
		[:x |  "simulate highlight by circles of gray"
		(Form dotOfSize: x*diam//5) displayOn: highlight
			at: (diam*2//5) asPoint clippingBox: highlight boundingBox
			rule: Form under mask: (Form perform:
					(#(black gray lightGray white veryLightGray) at: x))].
	(Form dotOfSize: diam) displayOn: highlight at: (diam//2) asPoint rule: Form and.
	highlight reverse.  "It will be used as a negative mask"
	ball _ Form dotOfSize: diam + 2.
	port _ BitBlt toForm: Display.
	queue _ SharedQueue new: 32.
	16 timesRepeat: [queue nextPut: -20@-20].
	filter _ Sensor cursorPoint.
	[Sensor yellowButtonPressed] whileFalse:
		[filter _ filter * 4 + Sensor cursorPoint // 5.
		point _ Sensor redButtonPressed
			ifTrue: [filter] ifFalse: [-20@-20].
		port copyForm: ball to: point rule: Form under.
		port copyForm: highlight to: queue next rule: Form and.
		queue nextPut: point]! !

Form class removeSelector: #toothpaste!
