'From Smalltalk-80 of March 1st, 1985 on 14 March 1985 at 11:46:05 am'!



!BitBlt methodsFor: 'private'!
setDestForm: aForm
	| extent |
	destForm _ aForm.
	clipX _ 0.
	clipY _ 0.
	extent _ destForm extent.
	clipWidth _ extent x.
	clipHeight _ extent y! !
	
!BitBlt methodsFor: 'access'!
sourceX: anInteger 
	"Set the receiver's source form top left x to be the argument, anInteger."

	sourceX _ anInteger! !

!Browser methodsFor: 'system category functions'!
printOutSystemCategories
	"Print a description of each class in the selected category on the printer."
	| aFileStream |
	systemCategoryListIndex = 0 ifTrue: [^ self].
	aFileStream _ MacPrintStream open.
	systemOrganizer fileOutCategory: self selectedSystemCategoryName on: aFileStream.
	aFileStream cr; close! !

!Browser methodsFor: 'class functions'!
printOutClass
	"Print a description of the selected class on the printer."
	| fileStream |
	classListIndex = 0 ifTrue: [^ self].
	fileStream _ MacPrintStream open.
	fileStream timeStamp.
	self selectedClass fileOutOn: fileStream
		moveSource: false
		toFile: 0.
	fileStream cr; close! !

!Browser methodsFor: 'message category functions'!
fileOutMessageCategories
	"Print a description of the selected message category of the selected class on an external file."

	messageCategoryListIndex ~= 0
		ifTrue: 
			[self selectedClassOrMetaClass fileOutCategory: self selectedMessageCategoryName]!
printOutMessageCategories
	"Print a description of the selected message category of the selected class on the serial printer."
	| fileStream |
	messageCategoryListIndex ~= 0
		ifTrue: 
			[fileStream _ MacPrintStream open.
			fileStream timeStamp.
			self selectedClassOrMetaClass fileOutCategory: self selectedMessageCategoryName
				on: fileStream moveSource: false toFile: 0.
			fileStream cr; close]! !

!Browser methodsFor: 'message functions'!
fileOutMessage
	"Print a description of the selected message on the serial printer."
	| fileStream |
	messageCategoryListIndex = 0 ifTrue: [^ self].
	fileStream _ Disk file: (self selectedClassOrMetaClass name , '-' , self selectedMessageName) , '.st'.
	fileStream timeStamp.
	self selectedClassOrMetaClass printCategoryChunk: self selectedMessageCategoryName
		on: fileStream.
	self selectedClassOrMetaClass printMethodChunk: self selectedMessageName
		on: fileStream
		moveSource: false
		toFile: 0.
	fileStream nextChunkPut: ' '.
	fileStream shorten; close!
printOutMessage
	"Print a description of the selected message on the serial printer."
	| fileStream |
	messageCategoryListIndex = 0 ifTrue: [^ self].
	fileStream _ MacPrintStream open.
	fileStream timeStamp.
	self selectedClassOrMetaClass printCategoryChunk: self selectedMessageCategoryName
		on: fileStream.
	self selectedClassOrMetaClass printMethodChunk: self selectedMessageName
		on: fileStream
		moveSource: false
		toFile: 0.
	fileStream cr; close! !


!ClassDescription methodsFor: 'fileIn/Out'!
printCategoryChunk: aString on: aFileStream
	"Print the message describing that methods for the category aString follow 
	next on aFileStream."

	aFileStream cr; cr; emphasis: 5; nextPut: $!!.
	aFileStream nextChunkPut: (self name , ' methodsFor: ' , '''' , aString , '''').
	aFileStream emphasis: 1! !


!ClassListController methodsFor: 'menu messages'!
printOut
	"Print a description of the selected class on the printer."

	self controlTerminate.
	Cursor write showWhile:
		[model printOutClass].
	self controlInitialize! !


!CompiledMethod methodsFor: 'source code management'!
copySourceTo: aFileStream
	"Copy the source code for the receiver to aFileStream. Answer true if there are no 
	problems, false if no files specified in the global SourceFiles or position is zero."
	| position |
	SourceFiles == nil ifTrue: [^false].
	Cursor read
		showWhile: 
			[position _ self filePosition.
			position ~= 0
				ifTrue: [(SourceFiles at: self fileIndex) position: position.
						aFileStream copyChunkFrom: (SourceFiles at: self fileIndex)]].
	^position ~= 0! !


!Form methodsFor: 'accessing'!
extent
	^ width @ height! !

!Form methodsFor: 'image manipulation'!
rotate90  "From BYTE 8/81 by Daniel Ingalls"
	| mask temp quad all |
	temp _ Form extent: self extent.
	mask _ Form extent: self extent.
	all _ 0@0 extent: self extent.
	mask white; fill: (0@0 extent: self extent // 2) mask: Form black.
	quad _ width // 2.
	[quad >= 1] whileTrue:
		[	"First exchange the left and right halves"
		temp copy: all from: 0@0 in: mask rule: Form over.
		temp copy: all from: 0@(0-quad) in: mask rule: Form under.
		temp copy: all from: 0@0 in: self rule: Form and.
		self copy: all from: 0@0 in: temp rule: Form reverse.
		temp copy: all from: quad@0 in: self rule: Form reverse.
		self copy: all from: quad@0 in: self rule: Form under.
		self copy: all from: (0-quad)@0 in: temp rule: Form reverse.
			"Then flip the diagonals"
		temp copy: all from: 0@0 in: self rule: Form over.
		temp copy: all from: quad@quad in: self rule: Form reverse.
		temp copy: all from: 0@0 in: mask rule: Form and.
		self copy: all from: 0@0 in: temp rule: Form reverse.
		self copy: all from: (0-quad)@(0-quad) in: temp rule: Form reverse.
			"Compute the next finer mask"
		mask copy: all from: (quad//2)@(quad//2) in: mask rule: Form and.
		mask copy: all from: (0-quad)@0 in: mask rule: Form under.
		mask copy: all from: 0@(0-quad) in: mask rule: Form under.
		quad _ quad // 2]
	"[Sensor anyButtonPressed] whileFalse:
		[(Form fromDisplay: (Sensor cursorPoint extent: 64@64)) rotate90 display]"! !


!MessageCategoryListController methodsFor: 'menu messages'!
printOut
	"Print a description of the messages in the selected category to the serial printer."

	self controlTerminate.
	Cursor write showWhile:
		[model printOutMessageCategories].
	self controlInitialize! !


!MessageListController methodsFor: 'menu messages'!
fileOut
	"Print a description of the selected message onto an external file."

	self controlTerminate.
	Cursor write showWhile:
		[model fileOutMessage].
	self controlInitialize!
printOut
	"Print a description of the selected message on the printer."

	self controlTerminate.
	Cursor write showWhile:
		[model printOutMessage].
	self controlInitialize! !



!StandardSystemController methodsFor: 'menu messages'!
printBits
	"Print a copy of the bits in this window on the printer"
	| printStream |
	printStream _ MacPrintStream open.
	printStream printBits: (Form fromDisplay: view labelDisplayBox).
	view isCollapsed ifFalse: [printStream printBits: (Form fromDisplay: view displayBox)].
	printStream close! !


!StandardSystemController class methodsFor: 'class initialization'!
initialize
	ScheduledBlueButtonMenu _ PopUpMenu labels: 'print
label
move
frame
collapse
close' lines: #(2 5 ).
	ScheduledBlueButtonMessages _ #(printBits label move expand collapse close )

	"StandardSystemController initialize.
	ScheduledControllers scheduledControllers
		do: [:c | (c isKindOf: ScreenController)
			ifFalse: [c initializeBlueButtonMenu]]"! !



!StringHolderController class methodsFor: 'class initialization'!
initialize
	"Initialize the yellow button pop-up menu and corresponding messages."

	CodeYellowButtonMenu _ 
		PopUpMenu 
			labels: 
'again
undo
copy
cut
paste
do it
print it
accept
cancel
print' 
		lines: #(2 5 7 9).
	CodeYellowButtonMessages _ 
		#(again undo copySelection cut paste doIt printIt accept cancel printContents)

	"StringHolderController initialize"! !



!FileController class methodsFor: 'class initialization'!
initialize
	"Initialize the yellow button pop-up menu."

	FileYellowButtonMenu _
		PopUpMenu
			labels: 'again
undo
copy
cut
paste
do it
print it
file it in
put
get
print'
			lines: #(2 5 8 10).
	FileYellowButtonMessages _
		#(again undo copySelection cut paste doIt printIt fileItIn put get printContents )

	"FileController initialize"! !


!SystemCategoryListController methodsFor: 'menu messages'!
printOut
	"Print the classes in the selected category on the printer."

	self controlTerminate.
	Cursor write showWhile:
		[model printOutSystemCategories].
	self controlInitialize! !


!WriteStream methodsFor: 'fileIn/Out'!
copyChunkFrom: aReadStream
	"Copy the next chunk from aReadStream (must be different from the receiver) "
	| delimiter |
	delimiter _ $!!.
	aReadStream skipSeparators.
	self nextPutAll: (aReadStream upTo: delimiter); nextPut: delimiter.
	[aReadStream peekFor: delimiter] whileTrue:   "case of imbedded (doubled) delimiter"
			[self nextPut: delimiter;
				nextPutAll: (aReadStream upTo: delimiter);
				nextPut: delimiter].
!
nextChunkPut: aString
	"Append the argument, aString, to the receiver, doubling imbedded delimiters."

	| i remainder delimiter |
	delimiter _ $!!.
	remainder _ aString.
	[(i _ remainder indexOf: delimiter) = 0] whileFalse:
		[self nextPutAll: (remainder copyFrom: 1 to: i).
		self nextPut: delimiter.  "double imbedded delimiters"
		remainder _ remainder copyFrom: i+1 to: remainder size].
	self nextPutAll: remainder; nextPut: delimiter! !

HFSMacFileStream subclass: #MacPrintStream
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Files-Macintosh'!
MacPrintStream comment:
'MacPrintStream performs data encoding appropriate for driving the Apple Imagewriter printer.
Both text and graphical display modes are supported in a limited fashion.'!


!MacPrintStream methodsFor: 'initialization'!
initialize  "set useful printer parameters"
	self nextPutEscape: 'c'.  "Reset the printer"
	(Delay forMilliseconds: 100) wait.  "Wait for the printer to reset"
	self nextPutEscape: 'D';  "Set auto line-feed"
		nextPut: (Character value: 128); nextPut: (Character value: 0).
	self nextPutEscape: 'D '; nextPut: (Character value: 0). "Auto linefeed on line full"
	self nextPut: (Character value: 29).
		super nextPutAll: 'A@'.  "set top of form"
		1 to: 58 do: [:x | super nextPutAll: '@@'].
		super nextPutAll: 'C@'.  "set bottom of form"
		1 to: 6 do: [:x | super nextPutAll: '@@'].
		super nextPutAll: 'A@'. self nextPut: (Character value: 30).  "set top of next form"
	self nextPutEscape: 'p'.  "Set pica proportional"
	self nextPutEscape: '(004,008,012,016,020,024,028,032,036,040,044,048.'.  "Set tabs"
	self nextPutEscape: '+'; nextPutEscape: 'I'.  "Prepare to down-load custom characters"
	super nextPutAll: '^G'.  "define ^, width=7"
	#(0 4 2 127 2 4 0) do: [:x | self nextPut: (Character value: x)].
	super nextPutAll: '_I'.  "define _, width=10"
	#(0 16 56 84 16 16 16 16 16 0) do: [:x | self nextPut: (Character value: x)].
	self nextPut: (Character value: 4).  "end of custom char defs"!
close
	"Overridden to avoid closing, since it would kill mouse interrupts
	(see Inside Mac re Serial Drivers)."
	closed _ true!
open: readWriteCodeIgnored
"Overridden to avoid logging in volume, so shutDown/startup dont cause problems relating to closing."

 ^ super open: 0 "0 = read or write"! !

!MacPrintStream methodsFor: 'writing'!
copyChunkFrom: aReadStream
	"Copy the next chunk from aReadStream, but don't print the delimiters "
	| delimiter |
	delimiter _ $!!.
	aReadStream skipSeparators.
	self nextPutAll: (aReadStream upTo: delimiter).
	[aReadStream peekFor: delimiter] whileTrue:   "case of imbedded (doubled) delimiter"
			[self nextPut: delimiter; nextPutAll: (aReadStream upTo: delimiter)].!
emphasis: code
	self nextPut: (Character value: 27).
	self nextPut: (Character value: (code=5 ifTrue: [33] ifFalse: [34]))!
nextChunkPut: aString  "Don't print the delimiters"
	self nextPutAll: aString!
nextPutAll: aString
	| prev end i char |
	prev _ 1.  end _ aString size.
	i _ 0.
	[(i _ i+1) <= end] whileTrue:
		[char _ aString at: i.
		char = $_ ifTrue:
			[super nextPutAll: (aString copyFrom: prev to: i-1).
			self nextPutEscape: '''_'; nextPutEscape: '$'.
			prev _ i+1].
		char = $^ ifTrue:
			[super nextPutAll: (aString copyFrom: prev to: i-1).
			self nextPutEscape: '''^'; nextPutEscape: '$'.
			prev _ i+1]].
	super nextPutAll: (aString copyFrom: prev to: end)!
nextPutEscape: escapeString
	self nextPut: (Character value: 27).
	super nextPutAll: escapeString!
typeTEXT  "ignored"! !

!MacPrintStream methodsFor: 'graphics'!
printBits: aForm
	| widthString height heightString |
	self nextPutEscape: 'n'.  "set 72 dots/inch"
	self nextPutEscape: '>'.  "set left-to-right only"
	widthString _ aForm width printString.
	widthString _ (String new: 4-widthString size withAll: $ ) , widthString.
	0 to: aForm height-1 by: 8 do:
		[:y |
		height _ 8 min: aForm height-y.
		heightString _ (height*2) printString.
		heightString _ (String new: 2-heightString size withAll: $ ) , heightString.
		self nextPutEscape: 'T' , heightString.  "set vertical tab = height*2/144"
		self nextPutEscape: 'G' , widthString.  "send out a line of bits"
		super nextPutAll:
			(self printerBitsFor: (0@y extent: aForm width@height) in: aForm).
		self cr]!
printerBitsFor: band in: aForm
	"Return a string with one char for each printer pin column in
	band which is a rectangle 8 bits high or less"
	| w n1 n2 square bb x y strip stripBits printerString |
	w _ band width.
	n1 _ (w*8) asFloat sqrt.  "n1 = size of smallest square that band can fit in"
	n2 _ 1.					"n2 is n1 rounded up to a power of 2"
	[n2 < n1] whileTrue: [n2 _ n2*2].
	"n2 is power-of-2 size of square that will hold all of band"
	square _ Form extent: n2@n2.
	0 to: (w-1) // n2 do:  "Now pack band into the square as several rows"
		[:row |
		square copy: (0@(row*8) extent: n2@band height)
				from: (band origin + ((row*n2)@0))
				in: aForm rule: Form over].
	square rotate90.  "Now printer pin rows are laid out like bitmap bytes!!"
	strip _ Form extent: 16@1.
	stripBits _ String new: 2.
	strip bits: stripBits.  "risky!!"
	printerString _ String new: w.
	bb _ BitBlt destForm: strip sourceForm: square
		halftoneForm: nil combinationRule: Form over
		destOrigin: 0@0 sourceOrigin: (x _ n2-8) @ (y _ 0) extent: 8@1
		clipRect: strip boundingBox.
	1 to: w do:
		[:i |
		bb copyBits.  printerString at: i put: (stripBits at: 1).
		bb sourceY: (y _ y+1).
		y >= n2 ifTrue: [bb sourceX: (x _ x-8); sourceY: (y _ 0)]].
	^ printerString! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

MacPrintStream class
	instanceVariableNames: ''!


!HFSMacFileStream class methodsFor: 'instance creation'!
onPortNamed: portName
	| f |   "Open a stream on the serial ports without creating a file"
	f _ self on: FileDirectory default named: portName.
	f open ifFalse: [self error: 'Cannot open the printer port.'].
	^ f! !

!MacPrintStream class methodsFor: 'instance creation'!
open    "Return an open fileStream on the printer port"
	^ (self onPortNamed: '.BOUT') initialize!
printDisplayBits: aRectangle
	self open printBits: (Form fromDisplay: aRectangle); close! !

!MacPrintStream class methodsFor: 'examples'!
examples 
	"For a smoke test, try:
		MacPrintStream open nextPutAll: 'Hello'; cr; close.
	If this doesn't work, then you  have basic problems such as
		printer not set to 9600 baud, printer not plugged into port A, etc.
	Many examples are availbable in menus:
		Those in the browser print text; those in window title tabs print bits.
	To print current changes, use:
		MacPrintStream open fileOutChanges.
	To print a screen rectangle, use:
		MacPrintStream printDisplayBits: Rectangle fromUser.
	"! !

MessageListController initialize!
StandardSystemController initialize!
StringHolderController initialize!
BrowserCodeController initialize!
FileController initialize!

StandardSystemController allInstancesDo: [:c |
	c initializeBlueButtonMenu].
StandardSystemController allSubclassesDo: [:s |
	s allInstancesDo: [:c |
		c initializeBlueButtonMenu]].!
