'From Smalltalk-80 of December 19th, 1985 on 4 June 1983 at 12:58:11 pm'!




!HParamBlockRec methodsFor: 'access'!
csCode: value
	<primitive: 161 recordOffset: 26 type: 'I'>
^self primitiveFailed!
csParam: value
	<primitive: 161 recordOffset: 28 type: 'I'>
^self primitiveFailed! !

!HFSMacFileStream methodsFor: 'downloading'!
downLoadRS232
	"downLoad a file via port A (modem) at 1200 baud, terminate with ESC (ascii 27).
	For instance from a Model 100 lap computer,
	<In Smalltalk> (FileStream fileNamed: 'Model100.text') downLoadRS232.
	<On Model 100> Enter TelCom, Stat 58N2D, Term, Up<fileName>...
			when Upload finishes, type ESC to terminate.
		This should echo your file on the Model 100 screen,
		and leave a copy in 'Model100.text' on the default volume
	"
	| f g c breakChar |
	f _ MacSerialStream fileNamed: '.AIN'.  "Open the modem port for input"
	g _ MacSerialStream fileNamed: '.AOUT'.  "Open the modem port for output"
	g setControlParameters: 16rCC5E.  "Set 1200 baud, etc."
	breakChar _ Character value: 27.  "Escape"
	[(c _ f next) asciiValue = 27] whileFalse:
		[g nextPut: c.   "echo to sender"
		self nextPut: c].  "add to this file"
	f close. g close.
	self shorten; close! !

HFSMacFileStream subclass: #MacSerialStream
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Files-Macintosh'!

!MacSerialStream methodsFor: 'initialize'!
open: readWriteCodeIgnored
"Overridden to avoid loggin in volume, so Sutdown/startup dont cause problems related to closing."
 ^ super open: 0 "0 = read or write"!
close
	"Overridden to avoid closing, since it would kill mouse interrupts
	(see Inside Mac re Serial Drivers)."
	closed _ true!
setControlParameters: config
	"config is encoded as follows (see Inside Mac re: SerReset and PBControl):
	config = stop + parity + data + baud, where /all in hexadecimal.../
	stop =	(4000, 8000, C000) for (1, 1.5, 2) stop bits,
	parity =	(0, 1000, 2000, 3000) for (no, odd, no, even) parity,
	data =	(0, 400, 800, C00) for (5, 6, 7, 8) data bits per character
	baud =	(17C BD 5E 3E 2E 1E 16 0E 0A 04 00) for
			(300, 600, 1200 1800 2400 3600 4800 7200 9600 19200 57600) baud
	Thus, for instance, arg = 16rCC5E for
		2 stop bits, no parity, 1200 baud, and 8 data bits.
	Note also:
		You must open both input AND output ports before you can receive input.
		If you output too quickly after opening, or close too quickly after output,
		some characters may never get sent.  I add (Delay forMilliseconds: 100) wait."
	pbRec csCode: 8.
	pbRec csParam: config.
	^ Mac pbControl: pbRec async: False ! !

!MacSerialStream class methodsFor: 'instance creation'!
fileNamed: portName
	| f |   "Open a stream on the serial ports without creating a file"
	(#('.AOUT' '.BOUT' '.AIN' '.BIN') includes: portName asUppercase)
		ifFalse: [self notify: 'Not a valid serial port name'].
	f _ self on: FileDirectory default named: portName.
	f open ifFalse: [self error: 'Cannot open port ', portName].
	^ f! !
